/*
* Copyright (C) fastman92 <fastman92@gmail.com>, website: http://fastman92.com
* Licensed under the MIT License, see LICENSE at top level directory.
*
*/

#pragma once

// GTA San Andreas
namespace Game_GTASA
{
	enum eIplFile
	{
		IPL_FILE_generic = 0,
		IPL_FILE_levelmap_stream0 = 1,
		IPL_FILE_barriers1 = 2,
		IPL_FILE_barriers2 = 3,
		IPL_FILE_seabed_stream0 = 4,
		IPL_FILE_countn2_stream0 = 5,
		IPL_FILE_countn2_stream1 = 6,
		IPL_FILE_countn2_stream2 = 7,
		IPL_FILE_countn2_stream3 = 8,
		IPL_FILE_countn2_stream4 = 9,
		IPL_FILE_countn2_stream5 = 10,
		IPL_FILE_countn2_stream6 = 11,
		IPL_FILE_countn2_stream7 = 12,
		IPL_FILE_countn2_stream8 = 13,
		IPL_FILE_countryn_stream0 = 14,
		IPL_FILE_countryn_stream1 = 15,
		IPL_FILE_countryn_stream2 = 16,
		IPL_FILE_countryn_stream3 = 17,
		IPL_FILE_countrys_stream0 = 18,
		IPL_FILE_countrys_stream1 = 19,
		IPL_FILE_countrys_stream2 = 20,
		IPL_FILE_countrys_stream3 = 21,
		IPL_FILE_countrys_stream4 = 22,
		IPL_FILE_countrye_stream0 = 23,
		IPL_FILE_countrye_stream1 = 24,
		IPL_FILE_countrye_stream10 = 25,
		IPL_FILE_countrye_stream11 = 26,
		IPL_FILE_countrye_stream12 = 27,
		IPL_FILE_countrye_stream13 = 28,
		IPL_FILE_countrye_stream2 = 29,
		IPL_FILE_countrye_stream3 = 30,
		IPL_FILE_countrye_stream4 = 31,
		IPL_FILE_countrye_stream5 = 32,
		IPL_FILE_countrye_stream6 = 33,
		IPL_FILE_countrye_stream7 = 34,
		IPL_FILE_countrye_stream8 = 35,
		IPL_FILE_countrye_stream9 = 36,
		IPL_FILE_countryw_stream0 = 37,
		IPL_FILE_countryw_stream1 = 38,
		IPL_FILE_countryw_stream2 = 39,
		IPL_FILE_countryw_stream3 = 40,
		IPL_FILE_countryw_stream4 = 41,
		IPL_FILE_countryw_stream5 = 42,
		IPL_FILE_countryw_stream6 = 43,
		IPL_FILE_countryw_stream7 = 44,
		IPL_FILE_countryw_stream8 = 45,
		IPL_FILE_truthsfarm = 46,
		IPL_FILE_sfn_stream0 = 47,
		IPL_FILE_sfn_stream1 = 48,
		IPL_FILE_sfn_stream2 = 49,
		IPL_FILE_sfs_stream0 = 50,
		IPL_FILE_sfs_stream1 = 51,
		IPL_FILE_sfs_stream2 = 52,
		IPL_FILE_sfs_stream3 = 53,
		IPL_FILE_sfs_stream4 = 54,
		IPL_FILE_sfs_stream5 = 55,
		IPL_FILE_sfs_stream6 = 56,
		IPL_FILE_sfs_stream7 = 57,
		IPL_FILE_sfs_stream8 = 58,
		IPL_FILE_crack = 59,
		IPL_FILE_sfse_stream0 = 60,
		IPL_FILE_sfse_stream1 = 61,
		IPL_FILE_sfse_stream2 = 62,
		IPL_FILE_sfse_stream3 = 63,
		IPL_FILE_sfse_stream4 = 64,
		IPL_FILE_sfse_stream5 = 65,
		IPL_FILE_sfse_stream6 = 66,
		IPL_FILE_sfe_stream0 = 67,
		IPL_FILE_sfe_stream1 = 68,
		IPL_FILE_sfe_stream2 = 69,
		IPL_FILE_sfe_stream3 = 70,
		IPL_FILE_sfw_stream0 = 71,
		IPL_FILE_sfw_stream1 = 72,
		IPL_FILE_sfw_stream2 = 73,
		IPL_FILE_sfw_stream3 = 74,
		IPL_FILE_sfw_stream4 = 75,
		IPL_FILE_sfw_stream5 = 76,
		IPL_FILE_vegasn_stream0 = 77,
		IPL_FILE_vegasn_stream1 = 78,
		IPL_FILE_vegasn_stream2 = 79,
		IPL_FILE_vegasn_stream3 = 80,
		IPL_FILE_vegasn_stream4 = 81,
		IPL_FILE_vegasn_stream5 = 82,
		IPL_FILE_vegasn_stream6 = 83,
		IPL_FILE_vegasn_stream7 = 84,
		IPL_FILE_vegasn_stream8 = 85,
		IPL_FILE_vegass_stream0 = 86,
		IPL_FILE_vegass_stream1 = 87,
		IPL_FILE_vegass_stream2 = 88,
		IPL_FILE_vegass_stream3 = 89,
		IPL_FILE_vegass_stream4 = 90,
		IPL_FILE_vegass_stream5 = 91,
		IPL_FILE_vegase_stream0 = 92,
		IPL_FILE_vegase_stream1 = 93,
		IPL_FILE_vegase_stream2 = 94,
		IPL_FILE_vegase_stream3 = 95,
		IPL_FILE_vegase_stream4 = 96,
		IPL_FILE_vegase_stream5 = 97,
		IPL_FILE_vegase_stream6 = 98,
		IPL_FILE_vegase_stream7 = 99,
		IPL_FILE_vegase_stream8 = 100,
		IPL_FILE_vegasw_stream0 = 101,
		IPL_FILE_vegasw_stream1 = 102,
		IPL_FILE_vegasw_stream10 = 103,
		IPL_FILE_vegasw_stream11 = 104,
		IPL_FILE_vegasw_stream2 = 105,
		IPL_FILE_vegasw_stream3 = 106,
		IPL_FILE_vegasw_stream4 = 107,
		IPL_FILE_vegasw_stream5 = 108,
		IPL_FILE_vegasw_stream6 = 109,
		IPL_FILE_vegasw_stream7 = 110,
		IPL_FILE_vegasw_stream8 = 111,
		IPL_FILE_vegasw_stream9 = 112,
		IPL_FILE_las_stream0 = 113,
		IPL_FILE_las_stream1 = 114,
		IPL_FILE_las_stream2 = 115,
		IPL_FILE_las_stream3 = 116,
		IPL_FILE_las_stream4 = 117,
		IPL_FILE_las_stream5 = 118,
		IPL_FILE_las2_stream0 = 119,
		IPL_FILE_las2_stream1 = 120,
		IPL_FILE_las2_stream2 = 121,
		IPL_FILE_las2_stream3 = 122,
		IPL_FILE_las2_stream4 = 123,
		IPL_FILE_carter = 124,
		IPL_FILE_lae2_stream0 = 125,
		IPL_FILE_lae2_stream1 = 126,
		IPL_FILE_lae2_stream2 = 127,
		IPL_FILE_lae2_stream3 = 128,
		IPL_FILE_lae2_stream4 = 129,
		IPL_FILE_lae2_stream5 = 130,
		IPL_FILE_lae2_stream6 = 131,
		IPL_FILE_lae_stream0 = 132,
		IPL_FILE_lae_stream1 = 133,
		IPL_FILE_lae_stream2 = 134,
		IPL_FILE_lae_stream3 = 135,
		IPL_FILE_lae_stream4 = 136,
		IPL_FILE_lae_stream5 = 137,
		IPL_FILE_lan_stream0 = 138,
		IPL_FILE_lan_stream1 = 139,
		IPL_FILE_lan_stream2 = 140,
		IPL_FILE_lan2_stream0 = 141,
		IPL_FILE_lan2_stream1 = 142,
		IPL_FILE_lan2_stream2 = 143,
		IPL_FILE_lan2_stream3 = 144,
		IPL_FILE_lawn_stream0 = 145,
		IPL_FILE_lawn_stream1 = 146,
		IPL_FILE_lawn_stream2 = 147,
		IPL_FILE_lawn_stream3 = 148,
		IPL_FILE_law_stream0 = 149,
		IPL_FILE_law_stream1 = 150,
		IPL_FILE_law_stream2 = 151,
		IPL_FILE_law_stream3 = 152,
		IPL_FILE_law_stream4 = 153,
		IPL_FILE_law_stream5 = 154,
		IPL_FILE_law2_stream0 = 155,
		IPL_FILE_law2_stream1 = 156,
		IPL_FILE_law2_stream2 = 157,
		IPL_FILE_law2_stream3 = 158,
		IPL_FILE_law2_stream4 = 159,
		IPL_FILE_lahills_stream0 = 160,
		IPL_FILE_lahills_stream1 = 161,
		IPL_FILE_lahills_stream2 = 162,
		IPL_FILE_lahills_stream3 = 163,
		IPL_FILE_lahills_stream4 = 164,
		IPL_FILE_int_la_stream0 = 165,
		IPL_FILE_int_la_stream1 = 166,
		IPL_FILE_int_la_stream2 = 167,
		IPL_FILE_int_la_stream3 = 168,
		IPL_FILE_int_sf_stream0 = 169,
		IPL_FILE_int_veg_stream0 = 170,
		IPL_FILE_int_veg_stream1 = 171,
		IPL_FILE_int_veg_stream2 = 172,
		IPL_FILE_int_veg_stream3 = 173,
		IPL_FILE_gen_int2_stream0 = 174,
		IPL_FILE_gen_intb_stream0 = 175,
		IPL_FILE_gen_int3_stream0 = 176,
		IPL_FILE_gen_int4_stream0 = 177,
		IPL_FILE_gen_int4_stream1 = 178,
		IPL_FILE_gen_int4_stream2 = 179,
		IPL_FILE_gen_int5_stream0 = 180,
		IPL_FILE_gen_int5_stream1 = 181,
		IPL_FILE_gen_int5_stream2 = 182,
		IPL_FILE_gen_int5_stream3 = 183,
		IPL_FILE_gen_int5_stream4 = 184,
		IPL_FILE_gen_int5_stream5 = 185,
		IPL_FILE_gen_int5_stream6 = 186,
		IPL_FILE_gen_int5_stream7 = 187,
		IPL_FILE_stadint_stream0 = 188,
		IPL_FILE_savehous_stream0 = 189,
		IPL_FILE_savehous_stream1 = 190,
	};
}


// Bully Scholarschip Edition
namespace Game_BullyScholarschipEdition
{
	enum eIplFile
	{
		IPL_FILE_generic = 0,
		IPL_FILE_ftest = 1,
		IPL_FILE_iDropS = 2,
		IPL_FILE_iGrsrS = 3,
		IPL_FILE_iJockS = 4,
		IPL_FILE_iMGRaceA = 5,
		IPL_FILE_iMGRaceB = 6,
		IPL_FILE_iMGRaceC = 7,
		IPL_FILE_iPrepS = 8,
		IPL_FILE_iasylum = 9,
		IPL_FILE_iballtos = 10,
		IPL_FILE_ibarber = 11,
		IPL_FILE_ibkshop = 12,
		IPL_FILE_iboxing = 13,
		IPL_FILE_ichem = 14,
		IPL_FILE_icloth_p = 15,
		IPL_FILE_icloth_r = 16,
		IPL_FILE_icomshp = 17,
		IPL_FILE_ifreaks = 18,
		IPL_FILE_ifunhous = 19,
		IPL_FILE_igrocery = 20,
		IPL_FILE_iobserv = 21,
		IPL_FILE_ipbarb = 22,
		IPL_FILE_isalon = 23,
		IPL_FILE_isc_Gdrm = 24,
		IPL_FILE_isc_art = 25,
		IPL_FILE_isc_audt = 26,
		IPL_FILE_isc_auto = 27,
		IPL_FILE_isc_bio = 28,
		IPL_FILE_isc_boil = 29,
		IPL_FILE_isc_chem = 30,
		IPL_FILE_isc_clas = 31,
		IPL_FILE_isc_dorm = 32,
		IPL_FILE_isc_lib = 33,
		IPL_FILE_isc_offi = 34,
		IPL_FILE_isc_pool = 35,
		IPL_FILE_isc_prep = 36,
		IPL_FILE_isc_staf = 37,
		IPL_FILE_ischool = 38,
		IPL_FILE_ishoot = 39,
		IPL_FILE_isouvnir = 40,
		IPL_FILE_itenn = 41,
		IPL_FILE_itrailer = 42,
		IPL_FILE_iware = 43,
		IPL_FILE_tBMX = 44,
		IPL_FILE_tGlobal = 45,
		IPL_FILE_tbusines = 46,
		IPL_FILE_tcarni = 47,
		IPL_FILE_tgokart = 48,
		IPL_FILE_tindust = 49,
		IPL_FILE_tjyard = 50,
		IPL_FILE_trich = 51,
		IPL_FILE_tschool = 52,
		IPL_FILE_ttest = 53,
		IPL_FILE_zone_busines1 = 54,
		IPL_FILE_zone_busines2 = 55,
		IPL_FILE_zone_busines3 = 56,
		IPL_FILE_zone_busines4 = 57,
		IPL_FILE_zone_busines5 = 58,
		IPL_FILE_zone_busines6 = 59,
		IPL_FILE_zone_busines7 = 60,
		IPL_FILE_zone_busines8 = 61,
		IPL_FILE_zone_carn1 = 62,
		IPL_FILE_zone_indust1 = 63,
		IPL_FILE_zone_indust2 = 64,
		IPL_FILE_zone_indust3 = 65,
		IPL_FILE_zone_indust4 = 66,
		IPL_FILE_zone_indust5 = 67,
		IPL_FILE_zone_indust6 = 68,
		IPL_FILE_zone_rich1 = 69,
		IPL_FILE_zone_rich10 = 70,
		IPL_FILE_zone_rich11 = 71,
		IPL_FILE_zone_rich2 = 72,
		IPL_FILE_zone_rich3 = 73,
		IPL_FILE_zone_rich4 = 74,
		IPL_FILE_zone_rich5 = 75,
		IPL_FILE_zone_rich6 = 76,
		IPL_FILE_zone_rich7 = 77,
		IPL_FILE_zone_rich8 = 78,
		IPL_FILE_zone_rich9 = 79,	// this
		IPL_FILE_zone_school1 = 80,
		IPL_FILE_zone_school2 = 81,
		IPL_FILE_zone_school3 = 82,
		IPL_FILE_zone_school4 = 83,
		IPL_FILE_zone_school5 = 84,
		IPL_FILE_zone_school6 = 85,
		IPL_FILE_hope = 86
	};
}