/*
* Copyright (C) fastman92 <fastman92@gmail.com>, website: http://fastman92.com
* Licensed under the MIT License, see LICENSE at top level directory.
*
*/

#pragma once

namespace Game_GTAIII
{
	/*
	Handling ranges:
	0 - 56:	standard vehicles,		sizeof(CHandlingVehicle)	= xx (xx)
	*/

	enum eVehHandlingID
	{
		// standard vehicles
		HANDLING_LANDSTAL,
		HANDLING_IDAHO,
		HANDLING_STINGER,
		HANDLING_LINERUN,
		HANDLING_PEREN,
		HANDLING_SENTINEL,
		HANDLING_PATRIOT,
		HANDLING_FIRETRUK,
		HANDLING_TRASH,
		HANDLING_STRETCH,
		HANDLING_MANANA,
		HANDLING_INFERNUS,
		HANDLING_BLISTA,
		HANDLING_PONY,
		HANDLING_MULE,
		HANDLING_CHEETAH,
		HANDLING_AMBULAN,
		HANDLING_FBICAR,
		HANDLING_MOONBEAM,
		HANDLING_ESPERANT,
		HANDLING_TAXI,
		HANDLING_KURUMA,
		HANDLING_BOBCAT,
		HANDLING_MRWHOOP,
		HANDLING_BFINJECT,
		HANDLING_POLICE,
		HANDLING_ENFORCER,
		HANDLING_SECURICA,
		HANDLING_BANSHEE,
		HANDLING_PREDATOR,
		HANDLING_BUS,
		HANDLING_RHINO,
		HANDLING_BARRACKS,
		HANDLING_TRAIN,
		HANDLING_HELI,
		HANDLING_DODO,
		HANDLING_COACH,
		HANDLING_CABBIE,
		HANDLING_STALLION,
		HANDLING_RUMPO,
		HANDLING_RCBANDIT,
		HANDLING_BELLYUP,
		HANDLING_MRWONGS,
		HANDLING_MAFIA,
		HANDLING_YARDIE,
		HANDLING_YAKUZA,
		HANDLING_DIABLOS,
		HANDLING_COLUMB,
		HANDLING_HOODS,
		HANDLING_AIRTRAIN,
		HANDLING_DEADDODO,
		HANDLING_SPEEDER,
		HANDLING_REEFER,
		HANDLING_PANLANT,
		HANDLING_FLATBED,
		HANDLING_YANKEE,
		HANDLING_BORGNINE,
	};
}

namespace Game_GTAVC
{
	/*
	Handling ranges:
	0 - 161:	standard vehicles,		sizeof(CHandlingVehicle)	= 0xDC (220)
	81 - 85:	bikes					sizeof(CHandlingBike)		= 0x40 (64)
	86 - 95:	boats					sizeof(CHandlingBoat)		= 0x3C (60)
	96 - 96	flying & boat vehicle			sizeof(CHandlingBoat)		= 0x3C (60)
	97 - 105:	flying vehicles			sizeof(CHandlingFlying)		= 0x4C (76)
	*/

	enum eVehHandlingID
	{
		HANDLING_LANDSTAL,
		HANDLING_IDAHO,
		HANDLING_STINGER,
		HANDLING_LINERUN,
		HANDLING_PEREN,
		HANDLING_SENTINEL,
		HANDLING_PATRIOT,
		HANDLING_FIRETRUK,
		HANDLING_TRASH,
		HANDLING_STRETCH,
		HANDLING_MANANA,
		HANDLING_INFERNUS,
		HANDLING_PONY,
		HANDLING_MULE,
		HANDLING_CHEETAH,
		HANDLING_AMBULAN,
		HANDLING_FBICAR,
		HANDLING_MOONBEAM,
		HANDLING_ESPERANT,
		HANDLING_TAXI,
		HANDLING_KURUMA,
		HANDLING_BOBCAT,
		HANDLING_MRWHOOP,
		HANDLING_BFINJECT,
		HANDLING_POLICE,
		HANDLING_ENFORCER,
		HANDLING_SECURICA,
		HANDLING_BANSHEE,
		HANDLING_BUS,
		HANDLING_RHINO,
		HANDLING_BARRACKS,
		HANDLING_TRAIN,
		HANDLING_HELI,
		HANDLING_DODO,
		HANDLING_COACH,
		HANDLING_CABBIE,
		HANDLING_STALLION,
		HANDLING_RUMPO,
		HANDLING_RCBANDIT,
		HANDLING_MAFIA,
		HANDLING_AIRTRAIN,
		HANDLING_DEADDODO,
		HANDLING_FLATBED,
		HANDLING_YANKEE,
		HANDLING_GOLFCART,
		HANDLING_VOODOO,
		HANDLING_WASHING,
		HANDLING_CUBAN,
		HANDLING_ROMERO,
		HANDLING_PACKER,
		HANDLING_ADMIRAL,
		HANDLING_GANGBUR,
		HANDLING_ZEBRA,
		HANDLING_TOPFUN,
		HANDLING_GLENDALE,
		HANDLING_OCEANIC,
		HANDLING_HERMES,
		HANDLING_SABRE1,
		HANDLING_SABRETUR,
		HANDLING_PHEONIX,
		HANDLING_WALTON,
		HANDLING_REGINA,
		HANDLING_COMET,
		HANDLING_DELUXO,
		HANDLING_BURRITO,
		HANDLING_SPAND,
		HANDLING_BAGGAGE,
		HANDLING_KAUFMAN,
		HANDLING_RANCHER,
		HANDLING_FBIRANCH,
		HANDLING_VIRGO,
		HANDLING_GREENWOO,
		HANDLING_HOTRING,
		HANDLING_SANDKING,
		HANDLING_BLISTAC,
		HANDLING_BOXVILLE,
		HANDLING_BENSON,
		HANDLING_DESPERAD,
		HANDLING_LOVEFIST,
		HANDLING_BLOODRA,
		HANDLING_BLOODRB,

		// bikes
		HANDLING_BIKE,
		HANDLING_MOPED,
		HANDLING_DIRTBIKE,
		HANDLING_ANGEL,
		HANDLING_FREEWAY,
		
		// boats
		HANDLING_PREDATOR,
		HANDLING_SPEEDER,
		HANDLING_REEFER,
		HANDLING_RIO,
		HANDLING_SQUALO,
		HANDLING_TROPIC,
		HANDLING_COASTGRD,
		HANDLING_DINGHY,
		HANDLING_MARQUIS,
		HANDLING_CUPBOAT,

		// flying & boat vehicles
		HANDLING_SEAPLANE,

		// flying & boat vehicles
		HANDLING_SPARROW,
		HANDLING_SEASPAR,
		HANDLING_MAVERICK,
		HANDLING_COASTMAV,
		HANDLING_POLMAV,
		HANDLING_HUNTER,
		HANDLING_RCBARON,
		HANDLING_RCGOBLIN,
		HANDLING_RCCOPTER
	};
}

namespace Game_GTASA
{
	/*
	0x00C2B9C8 - CVehicleHandling, sizeof = 0xC624

	Handling ranges:
	0 - 161:	standard vehicles,		sizeof(CHandlingVehicle)	= 0xEO (224)
	162 - 174:	bikes					sizeof(CHandlingBike)		= 0x40 (64)
	175 - 185:	boats					sizeof(CHandlingBoat)		= 0x3C (60)
	186 - 186	flying & boat vehicle			sizeof(CHandlingBoat)		= 0x3C (60)
	187 - 209:	flying vehicles			sizeof(CHandlingFlying)		= 0x58 (88)
	*/
	
	enum eVehHandlingID
	{
		// cars
		HANDLING_LANDSTAL,
		HANDLING_BRAVURA,
		HANDLING_BUFFALO,
		HANDLING_LINERUN,
		HANDLING_PEREN,
		HANDLING_SENTINEL,
		HANDLING_DUMPER,
		HANDLING_FIRETRUK,
		HANDLING_TRASH,
		HANDLING_STRETCH,
		HANDLING_MANANA,
		HANDLING_INFERNUS,
		HANDLING_VOODOO,
		HANDLING_PONY,
		HANDLING_MULE,
		HANDLING_CHEETAH,
		HANDLING_AMBULAN,
		HANDLING_MOONBEAM,
		HANDLING_ESPERANT,
		HANDLING_TAXI,
		HANDLING_WASHING,
		HANDLING_BOBCAT,
		HANDLING_MRWHOOP,
		HANDLING_BFINJECT,
		HANDLING_PREMIER,
		HANDLING_ENFORCER,
		HANDLING_SECURICA,
		HANDLING_BANSHEE,
		HANDLING_BUS,
		HANDLING_RHINO,
		HANDLING_BARRACKS,
		HANDLING_HOTKNIFE,
		HANDLING_ARTICT1,
		HANDLING_PREVION,
		HANDLING_COACH,
		HANDLING_CABBIE,
		HANDLING_STALLION,
		HANDLING_RUMPO,
		HANDLING_RCBANDIT,
		HANDLING_ROMERO,
		HANDLING_PACKER,
		HANDLING_MONSTER,
		HANDLING_ADMIRAL,
		HANDLING_TRAM,
		HANDLING_AIRTRAIN,
		HANDLING_ARTICT2,
		HANDLING_TURISMO,
		HANDLING_FLATBED,
		HANDLING_YANKEE,
		HANDLING_GOLFCART,
		HANDLING_SOLAIR,
		HANDLING_TOPFUN,
		HANDLING_GLENDALE,
		HANDLING_OCEANIC,
		HANDLING_PATRIOT,
		HANDLING_HERMES,
		HANDLING_SABRE,
		HANDLING_ZR350,
		HANDLING_WALTON,
		HANDLING_REGINA,
		HANDLING_COMET,
		HANDLING_BURRITO,
		HANDLING_CAMPER,
		HANDLING_BAGGAGE,
		HANDLING_DOZER,
		HANDLING_RANCHER,
		HANDLING_FBIRANCH,
		HANDLING_VIRGO,
		HANDLING_GREENWOO,
		HANDLING_HOTRING,
		HANDLING_SANDKING,
		HANDLING_BLISTAC,
		HANDLING_BOXVILLE,
		HANDLING_BENSON,
		HANDLING_MESA,
		HANDLING_BLOODRA,
		HANDLING_BLOODRB,
		HANDLING_SUPERGT,
		HANDLING_ELEGANT,
		HANDLING_JOURNEY,
		HANDLING_PETROL,
		HANDLING_RDTRAIN,
		HANDLING_NEBULA,
		HANDLING_MAJESTIC,
		HANDLING_BUCCANEE,
		HANDLING_CEMENT,
		HANDLING_TOWTRUCK,
		HANDLING_FORTUNE,
		HANDLING_CADRONA,
		HANDLING_FBITRUCK,
		HANDLING_WILLARD,
		HANDLING_FORKLIFT,
		HANDLING_TRACTOR,
		HANDLING_COMBINE,
		HANDLING_FELTZER,
		HANDLING_REMINGTN,
		HANDLING_SLAMVAN,
		HANDLING_BLADE,
		HANDLING_FREIGHT,
		HANDLING_STREAK,
		HANDLING_VINCENT,
		HANDLING_BULLET,
		HANDLING_CLOVER,
		HANDLING_SADLER,
		HANDLING_RANGER,
		HANDLING_HUSTLER,
		HANDLING_INTRUDER,
		HANDLING_PRIMO,
		HANDLING_TAMPA,
		HANDLING_SUNRISE,
		HANDLING_MERIT,
		HANDLING_UTILITY,
		HANDLING_YOSEMITE,
		HANDLING_WINDSOR,
		HANDLING_MTRUCK_A,
		HANDLING_MTRUCK_B,
		HANDLING_URANUS,
		HANDLING_JESTER,
		HANDLING_SULTAN,
		HANDLING_STRATUM,
		HANDLING_ELEGY,
		HANDLING_RCTIGER,
		HANDLING_FLASH,
		HANDLING_TAHOMA,
		HANDLING_SAVANNA,
		HANDLING_BANDITO,
		HANDLING_FREIFLAT,
		HANDLING_CSTREAK,
		HANDLING_KART,
		HANDLING_MOWER,
		HANDLING_DUNE,
		HANDLING_SWEEPER,
		HANDLING_BROADWAY,
		HANDLING_TORNADO,
		HANDLING_DFT30,
		HANDLING_HUNTLEY,
		HANDLING_STAFFORD,
		HANDLING_NEWSVAN,
		HANDLING_TUG,
		HANDLING_PETROTR,
		HANDLING_EMPEROR,
		HANDLING_FLOAT,
		HANDLING_EUROS,
		HANDLING_HOTDOG,
		HANDLING_CLUB,
		HANDLING_ARTICT3,
		HANDLING_RCCAM,
		HANDLING_POLICE_LA,
		HANDLING_POLICE_SF,
		HANDLING_POLICE_VG,
		HANDLING_POLRANGER,
		HANDLING_PICADOR,
		HANDLING_SWATVAN,
		HANDLING_ALPHA,
		HANDLING_PHOENIX,
		HANDLING_BAGBOXA,
		HANDLING_BAGBOXB,
		HANDLING_STAIRS,
		HANDLING_BOXBURG,
		HANDLING_FARM_TR1,
		HANDLING_UTIL_TR1,
		HANDLING_ROLLER,

		// bikes
		HANDLING_BIKE,
		HANDLING_MOPED,
		HANDLING_DIRTBIKE,
		HANDLING_FCR900,
		HANDLING_NRG500,
		HANDLING_HPV1000,
		HANDLING_BF400,
		HANDLING_WAYFARER,
		HANDLING_QUADBIKE,
		HANDLING_BMX,
		HANDLING_CHOPPERB,
		HANDLING_MTB,
		HANDLING_FREEWAY,

		// boats
		HANDLING_PREDATOR,
		HANDLING_SPEEDER,
		HANDLING_REEFER,
		HANDLING_RIO,
		HANDLING_SQUALO,
		HANDLING_TROPIC,
		HANDLING_COASTGRD,
		HANDLING_DINGHY,
		HANDLING_MARQUIS,
		HANDLING_CUPBOAT,
		HANDLING_LAUNCH,

		// flying & boat vehicles
		HANDLING_SEAPLANE,

		// flying vehicles	
		HANDLING_VORTEX,
		HANDLING_RUSTLER,
		HANDLING_BEAGLE,
		HANDLING_CROPDUST,
		HANDLING_STUNT,
		HANDLING_SHAMAL,
		HANDLING_HYDRA,
		HANDLING_NEVADA,
		HANDLING_AT400,
		HANDLING_ANDROM,
		HANDLING_DODO,
		HANDLING_SPARROW,
		HANDLING_SEASPAR,
		HANDLING_MAVERICK,
		HANDLING_COASTMAV,
		HANDLING_POLMAV,
		HANDLING_HUNTER,
		HANDLING_LEVIATHN,
		HANDLING_CARGOBOB,
		HANDLING_RAINDANC,
		HANDLING_RCBARON,
		HANDLING_RCGOBLIN,
		HANDLING_RCRAIDER,
	};
}