/*
* Copyright (C) fastman92 <fastman92@gmail.com>, website: http://fastman92.com
* Licensed under the MIT License, see LICENSE at top level directory.
*
*/

#pragma once
#include "ForOtherProjects/Exports.h"

#include <limits.h>
#include <jni.h>
#include <vector>

#define PATH_LIMIT 1024

class CPluginLoader
{
public:
	static char ms_packageName[128];

	static char ms_InitialDirectory[PATH_LIMIT];	// EXE directory on Windows, slash on Android
	static char ms_StorageRootDirectory[PATH_LIMIT];	// EXE directory on Windows, STORAGE_ROOT on Android
	static char ms_StorageRootBaseDirectory[PATH_LIMIT];	// Unset on Windows, STORAGE_ROOT_BASE on Android

	static char ms_CacheDirectory[PATH_LIMIT];	// DEX cache directory

	static std::vector<tOnApplicationInit> ms_applicationInitFuncArray;

	JavaVM* m_javaVm;
	void* m_reserved;
	static char ms_applicationIdentifier[4];
	void* m_baseAddressForApplicationLibrary;

	static jobject ms_mainActivityDuringLaunch;

	// Sets path by function from loader
	static void GetApplicationLibDirectoryPath(char* libPluginPath);

	// Initializes
	bool InitialiseLoading(
		JavaVM* javaVm,
		void* reserved,
		const char* applicationIdentifier,
		void* baseAddressForApplicationLibrary
	);

	// Does plugin loading
	void DoPluginLoading(
		const char* libPluginPath
	);

	// Does application initialization stage
	static void DoAppInitializationStage(JNIEnv* jniEnv, jobject mainActivity);
};